﻿using System;
using System.Text;

namespace Platform.Geo
{
    public class GeoLocation : GeoBase
    {
        public string DisplayName { get; set; }
        public string Description { get; set; }
        public GeoPosition Position { get; set; }
        public string BuildingFloor { get; set; }
        public string BuildingName { get; set; }
        public string BuildingRoom { get; set; }
        public string BuildingWing { get; set; }
        public string Continent { get; set; }
        public string Country { get; set; }
        public string CountryCode { get; set; }
        public string District { get; set; }
        public string FormattedAddress { get; set; }
        public string Neighborhood { get; set; }
        public string PostCode { get; set; }
        public string Region { get; set; }
        public string RegionCode { get; set; }
        public string Street { get; set; }
        public string StreetNumber { get; set; }
        public string Town { get; set; }

        /// <summary>
        /// Format address
        /// </summary>
        /// <param name="element"></param>
        /// <returns></returns>
        public string AddressSummary
        {
            get
            {
                var result = new StringBuilder();
                var street = Street ?? "";
                result.Append(street);

                var number = StreetNumber ?? "";
                if (result.Length > 0 && !String.IsNullOrEmpty(number)) result.Append(" ");
                result.Append(number);

                var town = Town ?? "";
                if (result.Length > 0 && !String.IsNullOrEmpty(town)) result.Append(", ");
                result.Append(town);

                var region = Region ?? "";
                if (result.Length > 0 && !String.IsNullOrEmpty(region)) result.Append(" ");
                result.Append(region);

                var district = District ?? "";
                if (result.Length > 0 && !String.IsNullOrEmpty(district)) result.Append(" ");
                result.Append(district);

                var code = CountryCode ?? "";
                if (result.Length > 0 && code != "NLD") result.AppendFormat(", {0}", Country ?? "");

                return result.ToString();
            }
        }
    }
}
